/*
  The Broad Institute
  SOFTWARE COPYRIGHT NOTICE AGREEMENT
  This software and its documentation are copyright (2005) by the
  Broad Institute/Massachusetts Institute of Technology. All rights are
  reserved.

  This software is supplied without any warranty or guaranteed support
  whatsoever. Neither the Broad Institute nor MIT can be responsible for its
  use, misuse, or functionality.
*/
/* $Id: mutate.h,v 1.5 2006/11/15 20:33:49 sfs Exp $ */
#ifndef MUTATE_H
#define MUTATE_H

typedef struct mutatednodelist {
  nodeid node;
  struct mutatednodelist *next;
} MutNodeList;

/* the mutation occurred between anc_node1 and anc_node2
   and appears in the nodes listed in mutatednodelist */
typedef struct mutations {  
  double location;
  Node* anc_node1;
  Node* anc_node2;
  MutNodeList *mutnodes;
} Mutations;

void mutate_print (FILE* fileptr, Mutations * mutptr, Mutlist *mutlist, Haplos *chromlist);
MutNodeList * mutate_descendents (Node * tempnode, 
				  MutNodeList * mnlist, 
				  double loc);
void mutate_find_and_print (FILE *fileptr, int regionnum, 
			    double loc, double randmark,
			    genid  tree_age, Mutlist *muts, Haplos *haps);
void mutate_print_headers (FILE *); 
void mutate_print_sites (FILE * fileptr);

#endif /* MUTATE_H */

